<?php
/*
	V4.04 13 Nov 2003  (c) 2000-2003 John Lim (jlim@natsoft.com.my). All rights reserved.
	  Released under both BSD license and Lesser GPL library license. 
	  Whenever there is any discrepancy between the two licenses, 
	  the BSD license will take precedence. 
	  Set tabs to 4 for best viewing.

  	This class provides recordset pagination with 
	First/Prev/Next/Last links. 
	
	Feel free to modify this class for your own use as
	it is very basic. To learn how to use it, see the 
	example in adodb/tests/testpaging.php.
	
	"Pablo Costa" <pablo@cbsp.com.br> implemented Render_PageLinks().
	
	Please note, this class is entirely unsupported, 
	and no free support requests except for bug reports
	will be entertained by the author.

  EXAMPLE:
  
  include("class.synPager.php");
  $qry="SELECT * FROM articoli WHERE legge=1 $where order by data DESC";
  //$db=database, 'syntax'=identificativo, content.php=Target file, content=Target frame, true=show page links
  $pager = new synPager($db,'syntax', "content.php", "content", true);
  //$qry=sql query, 10=rows per page, "c=$c"=extra parameters passed to the page links 
  $res=$pager->Execute($qry,10,"c=$c"); 
  //...

  //stampa i bottoni di navigazione. (imgPath,pageIndex,currentPage)
  echo $pager->renderPager("admin/modules/aa/",true,false);
*/
class synPager extends ADODB_Pager{
	var $id; 	// unique id for pager (defaults to 'adodb')
	var $db; 	// ADODB connection object
	var $sql; 	// sql used
	var $rs;	// recordset generated
	var $curr_page;	// current page number before Render() called, calculated in constructor
	var $rows;		// number of rows per page
    var $linksPerPage=10; // number of links per page in navigation bar
    var $showPageLinks; 

	var $gridAttributes = 'width=100% border=1 bgcolor=white';
	
	// Localize text strings here
	var $first = '<code>|&lt;</code>';
	var $prev = '<code>&lt;&lt;</code>';
	var $next = '<code>>></code>';
	var $last = '<code>>|</code>';
	var $moreLinks = '...';
	var $startLinks = '...';
	var $gridHeader = false;
	var $htmlSpecialChars = true;
	var $page = 'Pag';
	var $linkSelectedColor = 'black';
	var $cache = 0;  #secs to cache with CachePageExecute()

  var $targetFile;
  var $targetFrame;

  var $firstPage;
  var $prevPage;
  var $nextPage;
  var $lastPage;
  var $index;
  var $footer;
	
	//----------------------------------------------
	// constructor
	//
	// $db	adodb connection object
	// $sql	sql statement
	// $id	optional id to identify which pager, 
	//		if you have multiple on 1 page. 
	//		$id should be only be [a-z0-9]*
	// $targetFile the file to be pointed in the page index
  // $targetFrame the frame to be pointed in the page index
	function synPager(&$db,$id = 'adodb', $targetFile, $targetFrame, $showPageLinks = false)
	{
	global $HTTP_SERVER_VARS,$PHP_SELF,$HTTP_SESSION_VARS,$HTTP_GET_VARS;
	
		$curr_page = $id.'_curr_page';
		if (empty($PHP_SELF)) $PHP_SELF = $HTTP_SERVER_VARS['PHP_SELF'];
		
		//$this->sql = $sql;
		$this->id = $id;
		$this->db = $db;
		$this->showPageLinks = $showPageLinks;
    
    $this->targetFile=$targetFile;
    $this->targetFrame=$targetFrame;
		
		$next_page = $id.'_next_page';	
		
		if (isset($HTTP_GET_VARS[$next_page])) {
			$HTTP_SESSION_VARS[$curr_page] = $HTTP_GET_VARS[$next_page];
		}
		if (empty($HTTP_SESSION_VARS[$curr_page])) $HTTP_SESSION_VARS[$curr_page] = 1; ## at first page
		
		$this->curr_page = $HTTP_SESSION_VARS[$curr_page];
		
	}
	
	//---------------------------
	// Display link to first page
	function Render_First($anchor=true, $parameters="")
	{
		if ($anchor) {
      if ($parameters!="") $parameters="&".$parameters;
      $ret=$this->targetFile."?".$this->id."_next_page=1".$parameters;
		} else {
      if ($parameters!="") $parameters="?".$parameters;
      $ret=$this->targetFile.$parameters;
		}
    return $ret;
	}
	
	//--------------------------
	// Display link to next page
	function render_next($anchor=true, $parameters="")
	{
		if ($anchor) {
      if ($parameters!="") $parameters="&".$parameters;
      $ret=$this->targetFile."?".$this->id."_next_page=".($this->rs->AbsolutePage() + 1).$parameters;
		} else {
      if ($parameters!="") $parameters="?".$parameters;
      $ret=$this->targetFile.$parameters;
		}
    return $ret;
	}
	
	//------------------
	// Link to last page
	// 
	// for better performance with large recordsets, you can set
	// $this->db->pageExecuteCountRows = false, which disables
	// last page counting.
	function render_last($anchor=true, $parameters="")
	{
		if (!$this->db->pageExecuteCountRows) return;
		
		if ($anchor) {
      if ($parameters!="") $parameters="&".$parameters;
      $ret=$this->targetFile."?".$this->id."_next_page=".$this->rs->LastPageNo().$parameters;
		} else {
      if ($parameters!="") $parameters="?".$parameters;
      $ret=$this->targetFile.$parameters;
		}
    return $ret;
	}
	
	//---------------------------------------------------
	// original code by "Pablo Costa" <pablo@cbsp.com.br> 
function myRender_PageLinks($parameters="") {
  global $PHP_SELF;

  $pages        = $this->rs->LastPageNo();
  $linksperpage = $this->linksPerPage ? $this->linksPerPage : $pages;


  for($i=1; $i <= $pages; $i+=$linksperpage) 
    if($this->rs->AbsolutePage() >= $i) $start = $i;

  $numbers = '';
  $end = $start+$linksperpage-1;
  $link = $this->id . "_next_page";
  if($end > $pages) $end = $pages;
  
  if ($this->startLinks && $start > 1) {
    $pos = $start - 1;
    $numbers .= "<a target=\"".$this->targetFrame."\" href=\"".$this->targetFile."?$link=$pos&$parameters\">$this->startLinks</a>  ";
  } 
  
  for($i=$start; $i <= $end; $i++) {
    if ($this->rs->AbsolutePage() == $i)
      $numbers .= "<font color=\"$this->linkSelectedColor\"><b>$i</b></font>  ";
    else 
      $numbers .= "<a target=\"".$this->targetFrame."\" href=\"".$this->targetFile."?$link=$i&$parameters\">$i</a>  ";
  }

  if ($this->moreLinks && $end < $pages) 
    $numbers .= "<a target=\"".$this->targetFrame."\" href=\"".$this->targetFile."?$link=$i&$parameters\">$this->moreLinks</a>  ";


  return $numbers;
}
        
        
	// Link to previous page
	function render_prev($anchor=true, $parameters="")
	{
		if ($anchor) {
      if ($parameters!="") $parameters="&".$parameters;
      $ret=$this->targetFile."?".$this->id."_next_page=".($this->rs->AbsolutePage() - 1).$parameters;
		} else {
      if ($parameters!="") $parameters="?".$parameters;
			$ret=$this->targetFile.$parameters;
		}
    return $ret;
	}
	
	//--------------------------------------------------------
	// Simply rendering of grid. You should override this for
	// better control over the format of the grid
	//
	// We use output buffering to keep code clean and readable.
	function RenderGrid()
	{
	global $gSQLBlockRows; // used by rs2html to indicate how many rows to display
		include_once(ADODB_DIR.'/tohtml.inc.php');
		ob_start();
		$gSQLBlockRows = $this->rows;
		rs2html($this->rs,$this->gridAttributes,$this->gridHeader,$this->htmlSpecialChars);
		$s = ob_get_contents();
		ob_end_clean();
		return $s;
	}
	
	//-------------------------------------------------------
	// Navigation bar
	//
	// we use output buffering to keep the code easy to read.
	function RenderNav($parameters)
	{
    $ret=array();
		if (!$this->rs->AtFirstPage()) {
			$ret[0]=$this->Render_First(true,$parameters);
			$ret[1]=$this->Render_Prev(true,$parameters);
		} else {
			$ret[0]=$this->Render_First(false,$parameters);
			$ret[1]=$this->Render_Prev(false,$parameters);
		}
    if ($this->showPageLinks){
      $ret[4]=$this->myRender_PageLinks($parameters);
    }
		if (!$this->rs->AtLastPage()) {
			$ret[2]=$this->Render_Next(true,$parameters);
			$ret[3]=$this->Render_Last(true,$parameters);
		} else {
			$ret[2]=$this->Render_Next(false,$parameters);
			$ret[3]=$this->Render_Last(false,$parameters);
		}

		return $ret;
	}
	
	//-------------------
	// This is the footer
	function RenderPageCount()
	{
		if (!$this->db->pageExecuteCountRows) return '';
		$lastPage = $this->rs->LastPageNo();
		if ($lastPage == -1) $lastPage = 1; // check for empty rs.
		return "<font size=-1>$this->page ".$this->curr_page."/".$lastPage."</font>";
	}
	
	//-----------------------------------
	// Call this class to draw everything.
	function Execute($sql,$rows=10,$parameters="")
	{
	global $ADODB_COUNTRECS;
	
    $this->sql = $sql;
		$this->rows = $rows;
		
		$savec = $ADODB_COUNTRECS;
		if ($this->db->pageExecuteCountRows) $ADODB_COUNTRECS = true;
		if ($this->cache)
			$rs = &$this->db->CachePageExecute($this->cache,$this->sql,$rows,$this->curr_page);
		else
			$rs = &$this->db->PageExecute($this->sql,$rows,$this->curr_page);
		$ADODB_COUNTRECS = $savec;
		
		$this->rs = &$rs;
		if (!$rs) {
			print "<h3>Query failed: $this->sql</h3>";
			return;
		}
		
		//if (!$rs->EOF && (!$rs->AtFirstPage() || !$rs->AtLastPage())) 
			$header = $this->RenderNav($parameters);
		//else
		//	$header = "";
		
		//$grid = $this->RenderGrid();
		$footer = $this->RenderPageCount();
		//$rs->Close();
		//$this->rs = false;
		$this->RenderLayout($header,$grid,$footer);
    return $this->rs;
	}
	
	//------------------------------------------------------
	// override this to control overall layout and formating
	function RenderLayout($header,$grid,$footer,$attributes='border=1 bgcolor=beige')
	{
    $this->firstPage=$header[0];
    $this->prevPage=$header[1];
    $this->nextPage=$header[2];
    $this->lastPage=$header[3];
    $this->index=$header[4];
    $this->footer=$footer;
	}



  function renderPager($imgdir,$showindex=true,$showfooter=true) {
    $txt.= "    <table cellpadding=\"0\" cellspacing=\"0\" style=\"text-align: center\">\n" ;
    $txt.= "      <tr>\n" ;
 		if ($this->rs->AtFirstPage()) {
      $txt.= "        <td><img src=\"".$imgdir."images/start-d.gif\" style=\"border: 0px; margin: 0 5px 0 5px;\" /></td>\n" ;
      $txt.= "        <td><img src=\"".$imgdir."images/prev-d.gif\" style=\"border: 0px; margin: 0 5px 0 5px;\" /></td>\n" ;
    } else {
      $txt.= "        <td><a href=\"$this->firstPage\" id=\"start\"><img src=\"".$imgdir."images/start.gif\" alt=\"Vai alla prima pagina\" style=\"border: 0px; margin: 0 5px 0 5px;\" onmouseover=\"javascript: this.src='".$imgdir."images/start-o.gif'\" onmouseout=\"javascript: this.src='".$imgdir."images/start.gif'\" onmousedown=\"javascript: this.src='".$imgdir."images/start-c.gif'\" onmouseup=\"javascript: this.src='".$imgdir."images/start.gif'\"></a></td>\n" ;
      $txt.= "        <td><a href=\"$this->prevPage\" id=\"prev\"><img src=\"".$imgdir."images/prev.gif\" alt=\"Pagina precedente\" style=\"border: 0px; margin: 0 5px 0 5px;\" onmouseover=\"javascript: this.src='".$imgdir."images/prev-o.gif'\" onmouseout=\"javascript: this.src='".$imgdir."images/prev.gif'\" onmousedown=\"javascript: this.src='".$imgdir."images/prev-c.gif'\" onmouseup=\"javascript: this.src='".$imgdir."images/prev.gif'\"></a></td>\n" ;
    }
		if ($this->rs->AtLastPage()) {
      $txt.= "        <td><img src=\"".$imgdir."images/next-d.gif\" style=\"border: 0px; margin: 0 5px 0 5px;\" /></td>\n" ;
      $txt.= "        <td><img src=\"".$imgdir."images/end-d.gif\" style=\"border: 0px; margin: 0 5px 0 5px;\" /></td>\n" ;
    } else {
      $txt.= "        <td><a href=\"$this->nextPage\" id=\"next\"><img src=\"".$imgdir."images/next.gif\" alt=\"Pagina successiva\" style=\"border: 0px; margin: 0 5px 0 5px;\" onmouseover=\"javascript: this.src='".$imgdir."images/next-o.gif'\" onmouseout=\"javascript: this.src='".$imgdir."images/next.gif'\" onmousedown=\"javascript: this.src='".$imgdir."images/next-c.gif'\" onmouseup=\"javascript: this.src='".$imgdir."images/next.gif'\"></a></td>\n" ;
      $txt.= "        <td><a href=\"$this->lastPage\" id=\"end\"><img src=\"".$imgdir."images/end.gif\" alt=\"Vai all'ultima pagina\" style=\"border: 0px;  margin: 0 5px 0 5px;\" onmouseover=\"javascript: this.src='".$imgdir."images/end-o.gif'\" onmouseout=\"javascript: this.src='".$imgdir."images/end.gif'\" onmousedown=\"javascript: this.src='".$imgdir."images/end-c.gif'\" onmouseup=\"javascript: this.src='".$imgdir."images/end.gif'\"></a></td>\n" ;
    }
    $txt.= "      </tr>\n" ;

    if ($showindex===true) {
      $txt.= "    <tr><td colspan=\"4\">".$this->index."</td></tr>";
    }
    if ($showfooter===true) {
      $txt.= "    <tr><td colspan=\"4\">".$this->footer."</td></tr>";
    }
    $txt.= "    </table>\n" ;
    return $txt;
  }


}



?>
